/********************************************************************
* DTW - very simple prog to perform dtw.
*
* reads two parameter files, the number of coeffs, outputs the distance
*********************************************************************/

/********************* definitions, all others done in seglib  **********/
#include "common.h"
#include "speech1.h"

/* #define DEBUG */

/* ------------------- MAIN ------------------------------------ */
void main (int  argc, char **argv)  {

  FILE *fin1, *fin2;
  char *nin1, *nin2;
  int P;
  long bytes, N1, N2, il;
  float **a1, **a2, dist;

  if (argc != 4)
     ErrorExit ("Syntax: dtw file1.cps file2.cps P\n");

  nin1 = argv[1]; 
  nin2 = argv[2];
  P= atoi(argv[3]);

  /* alloc and read files */
  
  fin1 = File_Open (nin1, "r", "dtw");
  fin2 = File_Open (nin2, "r", "dtw");
  fseek(fin1, 0, SEEK_END); N1 = ftell(fin1)  / sizeof(float) / P;
  fseek(fin2, 0, SEEK_END); N2 = ftell(fin2)  / sizeof(float) / P;
  rewind (fin1);
  rewind (fin2);
 
  a1=Alloc_2_Float (N1, P);
  a2=Alloc_2_Float (N2, P);

  for (il=0; il<N1; il++) fread (a1[il], sizeof(float), P, fin1);
  for (il=0; il<N2; il++) fread (a2[il], sizeof(float), P, fin2);
  fclose (fin1);
  fclose (fin2);
  
  /* compare the files using dtw */

  dist = DTWDistance (a1, a2, N1, N2, P, NULL);
#ifdef DEBUG 
  printf ("%s %d frames, %s %d frames, dist=%f\n", nin1, N1, nin2, N2, dist);
#endif
  printf ("%f\n", dist);

  exit (0);
  
  
}
