/**********************************************************************
* SPEECH1.H - header for collection of functions for speech processing
* 
* Author:  		Jan Cernocky
* Created: 		16/10/97
* Last modification:	17/3/98
*********************************************************************/

/* defines - only a few */

#define BIG_FLOAT_VALUE 1e30
#define PI 3.1415926

/* prototypes */

float SqEuclidDistance (float *pfA, float *pfB, short swLen);
float DTWDistance (float **ppfR, float **ppfT, 
			short swLenR, short swLenT, short swSize, short *Path);
float ScalarQuant (float *pfCB, short L, float pfInput, short *pswIndex);
void MedianFilter (float *pfIn, long L_L, short swM, float *pfOut);
void MeanFilter (float *pfIn, long L_L, short swM, float *pfOut);
void LinearWarping (short swLenRef, short swLenTest, short *pswPath);
/* new oct 2002 */ 
void CenterVector (float *pfV, long L_LengthV);
float EnergyNoWindow (float *pfSFrame, short swLseg);
void Autocorrelation(float *pfWFrame, float *pfR, short swLseg, short swLpcOrder);
void HammingFrame  (float *pfSFrame, float *pfWSFrame, short swLseg); 
short Leroux (float *pfR, float *pfK, short swLpcOrder);
float ResidualEnergy (float fSE, float *pfK, short swLpcOrder);
void RflToLpc (float *pfR, float *pfA, short swLpcOrder);
void LpcToCps (float *pfA, float *pfC, short swLpcOrder, short swCpsNumber); 

